#! /usr/bin/env python
import sys, os, inspect
currentdir = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
parentdir = os.path.dirname(currentdir)
sys.path.insert(0,parentdir)
from server import *

from flask import Flask, render_template, redirect, url_for, Response, request, jsonify
from time import sleep,time
from werkzeug.contrib.fixers import ProxyFix
import io

app = Flask(__name__)

class sig:
	camera = None
	stream = None
	flag = False
	camera_enable = False
	sleep = 0.04
	detach = False
	lock = False

def shutdown_server():
    func = request.environ.get('werkzeug.server.shutdown')
    if not func is None:
        func()
    Signal.serv.close_request()
    Signal.serv.close()

@app.route('/')
def homepage():
	return render_template('index_bs.html')

@app.route('/video_surveillance')
def video_sur():
	sig.detach=False
	return render_template('video_surveillance_bs.html')
	
@app.route('/control')
def control():
	return render_template('control.html')
	
@app.route('/video_feed')
def video_feed():
	"""Video streaming route. Put this in the src attribute of an img tag."""
	return "True"
					
@app.route('/_update', methods = ['GET', 'POST'])
def list_update():
    t = request.form['type']
    if t == "load":
        attr = [i.encode('ascii','ignore') for i in request.form.getlist("attributes[]")]
    sleep(0.4)
    res = {}
    for i in attr:
        if i+"_status" in Signal.serv.update_msg_list.keys():
            res[i+"_status"] = Signal.serv.get_update(i+"_status")
        else:
            res[i+"_status"] = False
    return jsonify(status=res)
   
@app.route('/_control', methods = ['GET', 'POST'])
def param_control():
    t = request.form['type'].encode('ascii','ignore')
    val = request.form['value'].encode('ascii','ignore')
    #update_param(t, val)
    #poll_until_update_name(t+"_status", 99999)
    #sleep(0.4)
    #print t, Signal.serv.get_update(t+"_status")
    #return jsonify(status=Signal.serv.get_update(t+"_status"))
    print t, val
    sleep (0.5)
    return jsonify(status="2")
    
@app.route('/_camera_ctrl', methods=['GET','POST'])
def camera_ctrl():
	t = request.form['type']
	print "request detected..."
	if t == 'liveview':
		a = request.form.get('enableLV', 0, type=int)
		if a == 1:
			sig.camera_enable=True
			sig.flag=True
		else:
			sig.camera_enable=False
			sig.flag=False
	elif t == 'detach':
		sig.detach = True
	return "haha"

@app.route('/shutdown', methods=['POST','GET'])
def shutdown():
    shutdown_server()
    return 'Server shutting down...'	

app.wsgi_app = ProxyFix(app.wsgi_app)

if __name__ == '__main__':
	# initialize message host
    #init_server()
    
    # start camera
	
	# run the server
    app.run(host='0.0.0.0', debug=False, threaded=True)